#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <clocale>
#include <iostream>
#include <objbase.h>
#include <math.h>

#include "..\include\ioctl.h"
#include "..\include\ifc_ldev.h"
#include "..\include\create.h"
#include "..\include\pcicmd.h"
#include "..\include\791cmd.h"
#include "..\include\e2010cmd.h"
#include "..\include\e154cmd.h"

using namespace std;

USHORT   *fdata;
HANDLE hFile, hMap;
long fsize;

USHORT *data;
ULONG *sync;

//USHORT  *data1;
//ULONG *sync1;


ULONG status;
USHORT complete;

HANDLE hThread;
ULONG Tid;

USHORT IrqStep = 1024;//777-777%7; //     
USHORT FIFO = 1024;         //
USHORT pages = 128;
USHORT multi = 4; // -    ,    

//      
#pragma optimize ("", off)
ULONG WINAPI ServiceThread(PVOID /*Context*/)
{
   ULONG halfbuffer = IrqStep*pages/2;             //    
   ULONG fl2,fl1 = fl2 = (*sync<=halfbuffer)? 0:1; //  
   USHORT *tmp, *tmp1;
   for(int i=0;i<multi;i++)                        //     
   {
      while(fl2==fl1) fl2=(*sync<=halfbuffer)? 0:1; //    
      tmp=fdata+(halfbuffer*i);                    //    
      tmp1=data+(halfbuffer*fl1);                  //     
      memcpy(tmp,tmp1,halfbuffer*sizeof(USHORT));//    
      fl1=(*sync<=halfbuffer)? 0:1;                //  
      Sleep(0);                                    //        
   }
   complete=1;                                     //    
  return 0;                                          // 
}

#pragma optimize ("", on)

int main(int argc, char *argv[])
{
ADC_PAR adcPar;
DAC_PAR dacPar;
PLATA_DESCR_U2 pd;
SLOT_PAR sl;
ULONG slot;
USHORT d;
ULONG param;

   setlocale(LC_CTYPE, "");

   if(argc==1)
   {
      cout << "L-7XX simple example (L761,L780,L783,E440,E140,E2010)." << endl;
      cout << "(c) 2007 L-Card." << endl;
      cout << "Usage:" << endl;
      cout << "   client <slot number> <bios name>" << endl;
      cout << "   <slot number> - 0... (if one board installed - 0);" << endl;
      cout << "   <bios name>  - bios name without extension(l761 l780 l783 e2010 e440);" << endl;
      exit(1);
   }
   if(argc<3)
   {
      cout << "no params - exit!" << endl;
      exit(1);
   }

   cout << "Get IUnknown pointer" << endl;
#ifdef WIN64
   CallCreateInstance("lcomp64.dll");
#else
   CallCreateInstance("lcomp.dll");
#endif
   LUnknown* pIUnknown = CreateInstance(atoi(argv[1]));
   if(pIUnknown == NULL) { cout << "CallCreateInstance failed" << endl; return 1; }
   
   cout << "Get IDaqLDevice interface" << endl;
   IDaqLDevice* pI;
   HRESULT hr = pIUnknown->QueryInterface(IID_ILDEV,(void**)&pI);
   if(!SUCCEEDED(hr)) { cout << "Get IDaqLDevice failed" << endl; return 1; }
   cout << "IDaqLDevice get success" << endl;
   pIUnknown->Release();
   cout << "Free IUnknown" << endl;
   
   IDaqLDevice2* pI2;
   hr = pIUnknown->QueryInterface(IID_ILDEV2,(void**)&pI2);
   if(!SUCCEEDED(hr)) { cout << "Get IDaqLDevice2 failed" << endl; return 1; }
   cout << "IDaqLDevice2 get success" << endl;
   pIUnknown->Release();
   cout << "Free IUnknown" << endl;
   
   cout << "OpenLDevice Handle " << hex << pI->OpenLDevice() << endl;
   cout << "LoadBios status    " << pI->LoadBios(argv[2]) << endl;
   cout << "Plata test         " << pI->PlataTest() << endl;

   cout << endl << "Slot parameters" << endl;   
   pI->GetSlotParam(&sl);


   cout << "Base    " << hex << sl.Base << endl;
   cout << "BaseL   " << sl.BaseL << endl;
   cout << "Mem     " << sl.Mem << endl;
   cout << "MemL    " << sl.MemL << endl;
   cout << "Type    " << sl.BoardType << endl;
   cout << "DSPType " << sl.DSPType << endl;
   cout << "Irq     " << sl.Irq << endl;


   cout << endl << "Read FLASH" << endl;

   pI->ReadPlataDescr(&pd); // fill up properties

   switch (sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:  {
                  cout << "SerNum       " << pd.t1.SerNum << endl;
                  cout << "BrdName      " << pd.t1.BrdName << endl;
                  cout << "Rev          " << pd.t1.Rev << endl;
                  cout << "DspType      " << pd.t1.DspType << endl;
                  cout << "IsDacPresent " << pd.t1.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t1.Quartz << endl;
               } break;
   case E140:  {
                  cout << "SerNum       " << pd.t5.SerNum << endl;
                  cout << "BrdName      " << pd.t5.BrdName << endl;
                  cout << "Rev          " << pd.t5.Rev << endl;
                  cout << "DspType      " << pd.t5.DspType << endl;
                  cout << "IsDacPresent " << pd.t5.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t5.Quartz << endl;

                  cout << "ADC coef       " << dec << pd.t5.KoefADC[0] << endl;
                  cout << "ADC coef       " << dec << pd.t5.KoefADC[4] << endl;
               } break;
   case E440:  {
                  cout << "SerNum       " << pd.t4.SerNum << endl;
                  cout << "BrdName      " << pd.t4.BrdName << endl;
                  cout << "Rev          " << pd.t4.Rev << endl;
                  cout << "DspType      " << pd.t4.DspType << endl;
                  cout << "IsDacPresent " << pd.t4.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t4.Quartz << endl;
               } break;
   case E2010B:
   case E2010: {
                  cout << "SerNum       " << pd.t6.SerNum << endl;
                  cout << "BrdName      " << pd.t6.BrdName << endl;
                  cout << "Rev          " << pd.t6.Rev << endl;
                  cout << "DspType      " << pd.t6.DspType << endl;
                  cout << "IsDacPresent " << pd.t6.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t6.Quartz << endl;
               } break;
   case E154:  {
                  cout << "SerNum       " << pd.t7.SerNum << endl;
                  cout << "BrdName      " << pd.t7.BrdName << endl;
                  cout << "Rev          " << pd.t7.Rev << endl;
                  cout << "DspType      " << pd.t7.DspType << endl;
                  cout << "IsDacPresent " << pd.t7.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t7.Quartz << endl;
               }
   }

   cout << endl << "Press any key" << dec << endl;
   _getch();

//   
/*
   while(!kbhit())
   {
         ASYNC_PAR pp;
         pp.s_Type = L_ASYNC_ADC_INP;
         pp.Chn[0] = 32;
         pI->IoAsync(&pp);
         cout << (USHORT)pp.Data[0] << endl;
   }
*/
/*
         ASYNC_PAR pp;
         pp.s_Type = L_ASYNC_ADC_INP;
         pp.Chn[0] = 0xF;
         pI->IoAsync(&pp);
         cout << (USHORT)pp.Data[0] << endl;
*/
   ASYNC_PAR pp;
   pp.s_Type = L_ASYNC_TTL_CFG;
   pp.Mode = 1;
   pI->IoAsync(&pp);

   pp.s_Type = L_ASYNC_TTL_OUT;
   pp.Data[0] = 0xA525;
   pI->IoAsync(&pp);

   pp.s_Type = L_ASYNC_TTL_INP;
   pp.Data[0] = 1;
   pI->IoAsync(&pp);

   cout << "TTL input " << hex << pp.Data[0] << dec << endl;  

   pI->ReadPlataDescr(&pd); // fill up properties

   cout << "Press any key" << endl;
   _getch();

   DWORD tm = 10000000;
   pI->RequestBufferStream(&tm,L_STREAM_ADC);
   cout << "Allocated memory size(word): " << tm << endl;
   //   
   switch(sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:
   case E440:
   case E140:
   case E154:
      {
         adcPar.t1.s_Type = L_ADC_PARAM;
         adcPar.t1.AutoInit = 1;
         adcPar.t1.dRate = 100.0;
         adcPar.t1.dKadr = 0,0067;
         adcPar.t1.dScale = 0;
         adcPar.t1.SynchroType = 3; //3
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154) adcPar.t1.SynchroType = 0;//0
         adcPar.t1.SynchroSensitivity = 0;
         adcPar.t1.SynchroMode = 0;
         adcPar.t1.AdChannel = 0;
         adcPar.t1.AdPorog = 0;
         adcPar.t1.NCh = 6;
         adcPar.t1.Chn[0] = 0x0;
         adcPar.t1.Chn[1] = 0x1;
         adcPar.t1.Chn[2] = 0x2;
         adcPar.t1.Chn[3] = 0x3;
         adcPar.t1.FIFO = 1024;
         adcPar.t1.IrqStep = 1024;
         adcPar.t1.Pages = 128;
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154)
         {
            adcPar.t1.FIFO = 1536;//32768;
            adcPar.t1.IrqStep = 1536;//32768;
            adcPar.t1.Pages = 16;
         }
         adcPar.t1.IrqEna = 1;
         adcPar.t1.AdcEna = 1;

         pI->FillDAQparameters(&adcPar.t1);
         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t1.Pages << endl;
         cout << "IrqStep:           " << adcPar.t1.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t1.FIFO << endl;
         cout << "Rate:              " << adcPar.t1.dRate << endl;
         cout << "Kadr:              " << adcPar.t1.dKadr << endl;

         pI->SetParametersStream(&adcPar.t1, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t1.Pages << endl;
         cout << "IrqStep:           " << adcPar.t1.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t1.FIFO << endl;
         cout << "Rate:              " << adcPar.t1.dRate << endl;
         cout << "Kadr:              " << adcPar.t1.dKadr << endl;

         IrqStep = adcPar.t1.IrqStep;
         pages = adcPar.t1.Pages;

      } break;

   case E2010B:
   case E2010:
      {
         adcPar.t2.s_Type = L_ADC_PARAM;
         adcPar.t2.AutoInit = 1;
         adcPar.t2.dRate = 5000.0;
         adcPar.t2.dKadr = 0.01;
         adcPar.t2.SynchroType = 0x01;
         adcPar.t2.SynchroSrc = 0x00;
         adcPar.t2.AdcIMask = SIG_0|SIG_1|SIG_2|SIG_3;
         
         adcPar.t2.NCh = 4;
         adcPar.t2.Chn[0] = 0x0;
         adcPar.t2.Chn[1] = 0x1;
         adcPar.t2.Chn[2] = 0x2;
         adcPar.t2.Chn[3] = 0x3;
         adcPar.t2.FIFO = 32768;
         adcPar.t2.IrqStep = 32768;
         adcPar.t2.Pages = 32;
         adcPar.t2.IrqEna = 1;
         adcPar.t2.AdcEna = 1;

         // extra sync mode
         adcPar.t2.StartCnt = 0;
         adcPar.t2.StopCnt = 0;
         adcPar.t2.DM_Ena = 1;
         adcPar.t2.SynchroMode = A_SYNC_UP_EDGE | CH_0;
         adcPar.t2.AdPorog = 1;

         pI->FillDAQparameters(&adcPar.t2);
         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t2.Pages << endl;
         cout << "IrqStep:           " << adcPar.t2.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t2.FIFO << endl;
         cout << "Rate:              " << adcPar.t2.dRate << endl;

         adcPar.t2.dRate = 0;

         pI->SetParametersStream(&adcPar.t2, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t2.Pages << endl;
         cout << "IrqStep:           " << adcPar.t2.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t2.FIFO << endl;
         cout << "Rate:              " << adcPar.t2.dRate << endl;

         IrqStep = adcPar.t2.IrqStep;
         pages = adcPar.t2.Pages;

      }
   }

   cout << "Test GetParameter" << endl;
   pI->GetParameter(L_BOARD_TYPE, &param);
   cout << "Board Type " << param << endl;
   pI->GetParameter(L_SYNC_ADDR_LO, &param);
   cout << "Board Type " << hex << param << " " << sync << endl;



   cout << endl << "Press any key" << dec << endl;
   _getch();

   cout << "Started ..." << endl;
//  
   fsize=multi*(pages/2)*IrqStep; //  

   hFile=CreateFile("data.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                               NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);

   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*2,NULL);

   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata=(WORD *)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

   complete=0;

   pI->EnableCorrection();

//    
   //pI->InitStartLDevice();

   pI2->InitStartLDeviceEx(L_STREAM_ADC);

//      
   hThread=CreateThread(0,0x2000,ServiceThread,0,0,&Tid);//

   //    
   status=pI2->StartLDeviceEx(L_STREAM_ADC);

   //    
   while(!complete)
   {
      cout << *sync << endl;
      Sleep(20);
   }

   cout << "StartLDevice returned " <<  (status ? "TRUE":"FALSE") << endl;

   pI2->StopLDeviceEx(L_STREAM_ADC); //  

end:

   pI->CloseLDevice();
   pI->Release();

   CloseHandle(hThread);

   UnmapViewOfFile(fdata);
   CloseHandle(hMap);
   CloseHandle(hFile);

   cout << "Exit" << endl;
   return 0;
}
